\documentclass[a4paper,UTF8]{ctexart}
\usepackage{listings}
\newfontfamily\codefont{DejaVu Sans Mono}
\lstset{basicstyle=\footnotesize\codefont,frame=single,numbers=left}
\setCJKmainfont[Mapping = fullwidth-stop, % 中文空心句号映射为实心句点
  BoldFont=FZHei-B01,ItalicFont=FZKai-Z03,
  BoldItalicFont=FZFangSong-Z02]{FZNewShuSong-Z10}
\setCJKmonofont{gulim.ttf} % for 韩文字
\setmonofont{DejaVu Sans Mono}

\begin{document}
\subsection*{2022年第三届“网鼎杯”网络安全大赛，白虎组，misc620}

下载得到 {\small\tt{sqlmapHell\_bf72178c481c5e0443479d46c164af6a.zip}}，
解压时发现需要密码。

我决定使用 John the Ripper password cracker 暴力破解密码（猜测密码是纯数字）：
\begin{lstlisting}[numbers=none]
$ zip2john sqlmapHell_bf72178c481c5e0443479d46c164af6a.zip > /tmp/a
ver 2.0 sql.../flag.7z PKZIP Encr: cmplen=308, decmplen=291, crc=CDD0C633
ver 2.0 sql...ount.csv PKZIP Encr: cmplen=264, decmplen=295, crc=8D9A99A
NOTE: It is assumed that all files in each archive have the same password.
If that is not the case, the hash may be uncrackable. To avoid this, use
option -o to pick a file at a time.
$ john --inc:digits /tmp/a
Using default input encoding: UTF-8
Loaded 1 password hash (PKZIP [32/64])
Will run 8 OpenMP threads
Press 'q' or Ctrl-C to abort, almost any other key for status
99114514         (sqlmapHell_bf72178c481c5e0443479d46c164af6a.zip)
1g 0:00:00:02 DONE (2023-05-20 16:00) ... 99129838..99824164
Use the "--show" option to display all of the cracked passwords reliably
Session completed
\end{lstlisting}
得到密码：99114514。
解压后得到 {\tt{flag.7z}} 和 {\tt{sys\_account.csv}}。

解压 {\tt{flag.7z}} 时发现也需要密码。
查看 {\tt{sys\_account.csv}} 文件
发现 {\tt{password}} 字段的值 {\tt{7EqufFnrSGk=}}。
使用以下网站解密（注意，
{\tt{nmy0612}} 的 {\tt{MD5}}~码：
{\tt{1094\,c2b9\,ec4a\,ae7c\,59eb\,4869\,ca26\,ca5a}}，
而 {\tt{7EqufFnrSGk=}}
解码({\tt{base64}})：{\tt{ec4a\,ae7c\,59eb\,4869}}。
该网站从收录了海量 {\tt{MD5}} 码的数据库中查找出了这条记录。）：
\begin{lstlisting}[basicstyle=\small\codefont,numbers=none]
https://www.cmd5.com/
密文：7EqufFnrSGk=
类型：base64
查询结果：nmy0612
\end{lstlisting}

解压后得到 {\tt{flag.txt}}，其内容为：

\smallskip
\hspace*{-2.3em}\fbox{\parbox{1\textwidth}{\tt{
웬후ퟳ듳삨뫅뗘뛾튻튻뛾뻅뛾죽룜웟냋뗘쇹룜쯄쇣쇹쯄룜뻅웟웟쾸룜뇘웟죽뛾뻅웟뗘쾸쯄쯄뻅튻폒듳삨뫅
}}}

\medskip
{\tt{Unicode}} 收录了全部$11\,172$~个韩文字，
编码范围 {\tt{U+AC00-U+D7A3}}。
% 关于韩文字符集见 {\tt{https://zhuanlan.zhihu.com/p/24197668}}。
{\tt{GB2312}} 收录$6\,763$~个汉字，每个汉字以两个字节表示，
第一个字节编码范围 {\tt{0xB1-0xF7}}，
第二个字节编码范围 {\tt{0xA1-0xFE}}。

使用以下 C\# 程序 {\tt{a.cs}} 进行编码转换。
第~8~行从标准输入（重定向为 {\tt{flag.txt}}）读取以 {\tt{UTF8}} 编码的韩文字，
读入内存后自动转换为 {\tt{UTF16}}（{\tt{Unicode}}）编码，然后转换为字节数组。
第~9--10~行交换字节数组相邻两个字节。
第~11~行将字节数组视为 {\tt{GB2312}} 编码的汉字输出。
\lstinputlisting[language=C]{a.cs}

运行结果：
\begin{lstlisting}[numbers=none]
$ mcs a.cs && ./a.exe < flag.txt
旗帜左大括号地二一一二九二三杠七八地六杠四零六四杠九七七细杠必七三二九七地细
四四九一右大括号
\end{lstlisting}

最终得到：{\tt{flag\{d2112923-78d6-4064-977c-b73297dc4491\}}}。


\bigskip
\noindent 本题的解法来源于：

\noindent{\tt{https://zxw-nudt.blog.csdn.net/article/details/126582089}}

\end{document}
